#define ds_multimap_create
//ds_multimap_create()

return ds_map_create();


#define ds_multimap_add
//ds_multimap_add(id,key,value)

if (!ds_map_exists(argument0,argument1)) {
    ds_map_add(argument0,argument1,ds_list_create());
}

ds_list_add(ds_map_find_value(argument0,argument1),argument2);


#define ds_multimap_destroy
//ds_multimap_destroy(id)

if (!ds_map_empty(argument0)) 
{
    var a;

    repeat (ds_map_size(argument0)) 
    {
        a = ds_map_find_first(argument0);
        ds_list_destroy(ds_map_find_value(argument0,a));
        ds_map_delete(argument0,a);
    }
}

ds_map_destroy(argument0);


#define ds_multimap_clear
//ds_multimap_clear(id)

if (ds_map_empty(argument0)) {exit};

var a;

a = ds_map_find_first(argument0);
ds_list_destroy(ds_map_find_value(argument0,a));

repeat (ds_map_size(argument0)-1) 
{
    a = ds_map_find_next(argument0,a);
    ds_list_destroy(ds_map_find_value(argument0,a));
}

ds_map_clear(argument0);


#define ds_multimap_copy
//ds_multimap_copy(id,source)

ds_map_clear(argument0);
if (ds_map_empty(argument1)) {exit};

var a, b;

a = ds_map_find_first(argument1);
b = ds_list_create();
ds_list_copy(b,ds_map_find_value(argument1,a));
ds_map_add(argument0,a,b);

repeat (ds_map_size(argument1)-1) 
{
    a = ds_map_find_next(argument1,a);
    b = ds_list_create();
    ds_list_copy(b,ds_map_find_value(argument1,a));
    ds_map_add(argument0,a,b);
}


#define ds_multimap_size
//ds_multimap_size(id)

if (ds_map_empty(argument0)) {return 0};

var a, b;

a = ds_map_find_first(argument0);
b = ds_list_size(ds_map_find_value(argument0,a));

repeat (ds_map_size(argument0)-1) 
{
    a = ds_map_find_next(argument0,a);
    b += ds_list_size(ds_map_find_value(argument0,a));
}

return b;


#define ds_multimap_empty
//ds_multimap_empty(id)

return ds_map_empty(argument0);


#define ds_multimap_delete
//ds_multimap_delete(id,key,pos)

if (!ds_map_exists(argument0,argument1)) {exit};

var a;
    
a = ds_map_find_value(argument0,argument1);
ds_list_delete(a,argument2);
    
if (ds_list_empty(a)) 
{
    ds_list_destroy(a);
    ds_map_delete(argument0,argument1);
}


#define ds_multimap_exists
//ds_multimap_exists(id,key,value)

if (ds_map_exists(argument0,argument1)) {
    return (ds_list_find_index(ds_map_find_value(argument0,argument1),argument2) != -1);
} else {
    return false;
}


#define ds_multimap_replace
//ds_multimap_replace(id,key,pos,value)

if (ds_map_exists(argument0,argument1)) {
    ds_list_replace(ds_map_find_value(argument0,argument1),argument2,argument3);
}


#define ds_multimap_number
//ds_multimap_number(id,key)

if (ds_map_exists(argument0,argument1)) {
    return ds_list_size(ds_map_find_value(argument0,argument1));
} else {
    return 0;
}


#define ds_multimap_find_value
//ds_multimap_find_value(id,key,pos)

if (ds_map_exists(argument0,argument1)) {
    return ds_list_find_value(ds_map_find_value(argument0,argument1),argument2);
} else {
    return 0;
}


#define ds_multimap_find_first
//ds_multimap_find_first(id)

return ds_map_find_first(argument0);


#define ds_multimap_find_last
//ds_multimap_find_last(id)

return ds_map_find_last(argument0);


#define ds_multimap_find_next
//ds_multimap_find_next(id,key)

return ds_map_find_next(argument0,argument1);


#define ds_multimap_find_previous
//ds_multimap_find_previous(id,key)

return ds_map_find_previous(argument0,argument1);


#define ds_multimap_get_list
//ds_multimap_get_list(id,key)

var a;

a = ds_list_create();

if (ds_map_exists(argument0,argument1)) {
    ds_list_copy(a,ds_map_find_value(argument0,argument1));
}

return a;


#define ds_multimap_write
//ds_multimap_write(id)

var a, b;

b = ds_map_write(argument0);

if (!ds_map_empty(argument0)) 
{
    a = ds_map_find_first(argument0);
    b += "|"+ds_list_write(ds_map_find_value(argument0,a));

    repeat (ds_map_size(argument0)-1) 
    {
        a = ds_map_find_next(argument0,a);
        b += "|"+ds_list_write(ds_map_find_value(argument0,a));
    }
}

return b;


#define ds_multimap_read
//ds_multimap_read(id,str)

var a, b, c, i;

a = string_parse(argument1,"|",true);

ds_map_read(argument0,ds_list_find_value(a,0));

if (!ds_map_empty(argument0)) 
{
    b = ds_map_find_first(argument0);
    c = ds_list_create();
    ds_list_read(c,ds_list_find_value(a,1));
    ds_map_replace(argument0,b,c);

    for (i=2; i<ds_list_size(a); i+=1) 
    {
        b = ds_map_find_next(argument0,b);
        c = ds_list_create();
        ds_list_read(c,ds_list_find_value(a,i));
        ds_map_replace(argument0,b,c);
    }
}

ds_list_destroy(a);


#define ds_multimap_delete_key
//ds_multimap_delete_key(id,key)

if (!ds_map_exists(argument0,argument1)) {exit};
    
ds_list_destroy(ds_map_find_value(argument0,argument1));
ds_map_delete(argument0,argument1);


#define ds_multimap_count
//ds_multimap_count(id)

return ds_map_size(argument0);


#define ds_multimap_find_index
//ds_multimap_find_index(id,key,value)

if (ds_map_exists(argument0,argument1)) {
    return ds_list_find_index(ds_map_find_value(argument0,argument1),argument2);
} else {
    return -1;
}


#define ds_multimap_exists_key
//ds_multimap_exists_key(id,key)

return ds_map_exists(argument0,argument1);


#define ds_multimap_replace_key
//ds_multimap_replace_key(id,key,value)

if (!ds_map_exists(argument0,argument1)) {exit};

var a;
    
a = ds_map_find_value(argument0,argument1);
ds_list_clear(a);
ds_list_add(a,argument2); 


#define ds_multimap_insert
//ds_multimap_insert(id,key,pos,value)

if (!ds_map_exists(argument0,argument1)) {
    if (argument2 != 0) {exit};
    ds_map_add(argument0,argument1,ds_list_create());
}

ds_list_insert(ds_map_find_value(argument0,argument1),argument2,argument3);


#define ds_multimap_copy_key
//ds_multimap_copy_key(id,key,sourceid,sourcekey)

if (!ds_map_exists(argument2,argument3)) {exit};

if (!ds_map_exists(argument0,argument1)) {
    ds_map_add(argument0,argument1,ds_list_create());
}

ds_list_copy(ds_map_find_value(argument0,argument1),ds_map_find_value(argument2,argument3));


#define ds_multimap_add_list
//ds_multimap_add_list(id,key,listid)

var a;

if (!ds_map_exists(argument0,argument1)) 
{
    a = ds_list_create();
    ds_map_add(argument0,argument1,a);
    ds_list_copy(a,argument2);
}
else
{
    var i;
    
    a = ds_map_find_value(argument0,argument1);
    for (i=0; i<ds_list_size(argument2); i+=1)
    {
        ds_list_add(a,ds_list_find_value(argument2,i));
    }
}
